// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from performance_test:msg/RadarTrack.idl
// generated code does not contain a copyright notice
#include "performance_test/msg/detail/radar_track__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>

#include "rcutils/allocator.h"


// Include directives for member types
// Member `track_shape`
#include "performance_test/msg/detail/polygon__functions.h"
// Member `linear_velocity`
// Member `linear_acceleration`
#include "performance_test/msg/detail/vector3__functions.h"

bool
performance_test__msg__RadarTrack__init(performance_test__msg__RadarTrack * msg)
{
  if (!msg) {
    return false;
  }
  // track_id
  // track_shape
  if (!performance_test__msg__Polygon__init(&msg->track_shape)) {
    performance_test__msg__RadarTrack__fini(msg);
    return false;
  }
  // linear_velocity
  if (!performance_test__msg__Vector3__init(&msg->linear_velocity)) {
    performance_test__msg__RadarTrack__fini(msg);
    return false;
  }
  // linear_acceleration
  if (!performance_test__msg__Vector3__init(&msg->linear_acceleration)) {
    performance_test__msg__RadarTrack__fini(msg);
    return false;
  }
  // time
  // id
  return true;
}

void
performance_test__msg__RadarTrack__fini(performance_test__msg__RadarTrack * msg)
{
  if (!msg) {
    return;
  }
  // track_id
  // track_shape
  performance_test__msg__Polygon__fini(&msg->track_shape);
  // linear_velocity
  performance_test__msg__Vector3__fini(&msg->linear_velocity);
  // linear_acceleration
  performance_test__msg__Vector3__fini(&msg->linear_acceleration);
  // time
  // id
}

bool
performance_test__msg__RadarTrack__are_equal(const performance_test__msg__RadarTrack * lhs, const performance_test__msg__RadarTrack * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // track_id
  if (lhs->track_id != rhs->track_id) {
    return false;
  }
  // track_shape
  if (!performance_test__msg__Polygon__are_equal(
      &(lhs->track_shape), &(rhs->track_shape)))
  {
    return false;
  }
  // linear_velocity
  if (!performance_test__msg__Vector3__are_equal(
      &(lhs->linear_velocity), &(rhs->linear_velocity)))
  {
    return false;
  }
  // linear_acceleration
  if (!performance_test__msg__Vector3__are_equal(
      &(lhs->linear_acceleration), &(rhs->linear_acceleration)))
  {
    return false;
  }
  // time
  if (lhs->time != rhs->time) {
    return false;
  }
  // id
  if (lhs->id != rhs->id) {
    return false;
  }
  return true;
}

bool
performance_test__msg__RadarTrack__copy(
  const performance_test__msg__RadarTrack * input,
  performance_test__msg__RadarTrack * output)
{
  if (!input || !output) {
    return false;
  }
  // track_id
  output->track_id = input->track_id;
  // track_shape
  if (!performance_test__msg__Polygon__copy(
      &(input->track_shape), &(output->track_shape)))
  {
    return false;
  }
  // linear_velocity
  if (!performance_test__msg__Vector3__copy(
      &(input->linear_velocity), &(output->linear_velocity)))
  {
    return false;
  }
  // linear_acceleration
  if (!performance_test__msg__Vector3__copy(
      &(input->linear_acceleration), &(output->linear_acceleration)))
  {
    return false;
  }
  // time
  output->time = input->time;
  // id
  output->id = input->id;
  return true;
}

performance_test__msg__RadarTrack *
performance_test__msg__RadarTrack__create()
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  performance_test__msg__RadarTrack * msg = (performance_test__msg__RadarTrack *)allocator.allocate(sizeof(performance_test__msg__RadarTrack), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(performance_test__msg__RadarTrack));
  bool success = performance_test__msg__RadarTrack__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
performance_test__msg__RadarTrack__destroy(performance_test__msg__RadarTrack * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    performance_test__msg__RadarTrack__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
performance_test__msg__RadarTrack__Sequence__init(performance_test__msg__RadarTrack__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  performance_test__msg__RadarTrack * data = NULL;

  if (size) {
    data = (performance_test__msg__RadarTrack *)allocator.zero_allocate(size, sizeof(performance_test__msg__RadarTrack), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = performance_test__msg__RadarTrack__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        performance_test__msg__RadarTrack__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
performance_test__msg__RadarTrack__Sequence__fini(performance_test__msg__RadarTrack__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      performance_test__msg__RadarTrack__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

performance_test__msg__RadarTrack__Sequence *
performance_test__msg__RadarTrack__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  performance_test__msg__RadarTrack__Sequence * array = (performance_test__msg__RadarTrack__Sequence *)allocator.allocate(sizeof(performance_test__msg__RadarTrack__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = performance_test__msg__RadarTrack__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
performance_test__msg__RadarTrack__Sequence__destroy(performance_test__msg__RadarTrack__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    performance_test__msg__RadarTrack__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
performance_test__msg__RadarTrack__Sequence__are_equal(const performance_test__msg__RadarTrack__Sequence * lhs, const performance_test__msg__RadarTrack__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!performance_test__msg__RadarTrack__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
performance_test__msg__RadarTrack__Sequence__copy(
  const performance_test__msg__RadarTrack__Sequence * input,
  performance_test__msg__RadarTrack__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(performance_test__msg__RadarTrack);
    performance_test__msg__RadarTrack * data =
      (performance_test__msg__RadarTrack *)realloc(output->data, allocation_size);
    if (!data) {
      return false;
    }
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!performance_test__msg__RadarTrack__init(&data[i])) {
        /* free currently allocated and return false */
        for (; i-- > output->capacity; ) {
          performance_test__msg__RadarTrack__fini(&data[i]);
        }
        free(data);
        return false;
      }
    }
    output->data = data;
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!performance_test__msg__RadarTrack__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}
