// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from performance_test:msg/UnboundedSequence.idl
// generated code does not contain a copyright notice
#include "performance_test/msg/detail/unbounded_sequence__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>

#include "rcutils/allocator.h"


// Include directives for member types
// Member `unbounded_sequence`
#include "rosidl_runtime_c/primitives_sequence_functions.h"

bool
performance_test__msg__UnboundedSequence__init(performance_test__msg__UnboundedSequence * msg)
{
  if (!msg) {
    return false;
  }
  // unbounded_sequence
  if (!rosidl_runtime_c__octet__Sequence__init(&msg->unbounded_sequence, 0)) {
    performance_test__msg__UnboundedSequence__fini(msg);
    return false;
  }
  // time
  // id
  return true;
}

void
performance_test__msg__UnboundedSequence__fini(performance_test__msg__UnboundedSequence * msg)
{
  if (!msg) {
    return;
  }
  // unbounded_sequence
  rosidl_runtime_c__octet__Sequence__fini(&msg->unbounded_sequence);
  // time
  // id
}

bool
performance_test__msg__UnboundedSequence__are_equal(const performance_test__msg__UnboundedSequence * lhs, const performance_test__msg__UnboundedSequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // unbounded_sequence
  if (!rosidl_runtime_c__octet__Sequence__are_equal(
      &(lhs->unbounded_sequence), &(rhs->unbounded_sequence)))
  {
    return false;
  }
  // time
  if (lhs->time != rhs->time) {
    return false;
  }
  // id
  if (lhs->id != rhs->id) {
    return false;
  }
  return true;
}

bool
performance_test__msg__UnboundedSequence__copy(
  const performance_test__msg__UnboundedSequence * input,
  performance_test__msg__UnboundedSequence * output)
{
  if (!input || !output) {
    return false;
  }
  // unbounded_sequence
  if (!rosidl_runtime_c__octet__Sequence__copy(
      &(input->unbounded_sequence), &(output->unbounded_sequence)))
  {
    return false;
  }
  // time
  output->time = input->time;
  // id
  output->id = input->id;
  return true;
}

performance_test__msg__UnboundedSequence *
performance_test__msg__UnboundedSequence__create()
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  performance_test__msg__UnboundedSequence * msg = (performance_test__msg__UnboundedSequence *)allocator.allocate(sizeof(performance_test__msg__UnboundedSequence), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(performance_test__msg__UnboundedSequence));
  bool success = performance_test__msg__UnboundedSequence__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
performance_test__msg__UnboundedSequence__destroy(performance_test__msg__UnboundedSequence * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    performance_test__msg__UnboundedSequence__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
performance_test__msg__UnboundedSequence__Sequence__init(performance_test__msg__UnboundedSequence__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  performance_test__msg__UnboundedSequence * data = NULL;

  if (size) {
    data = (performance_test__msg__UnboundedSequence *)allocator.zero_allocate(size, sizeof(performance_test__msg__UnboundedSequence), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = performance_test__msg__UnboundedSequence__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        performance_test__msg__UnboundedSequence__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
performance_test__msg__UnboundedSequence__Sequence__fini(performance_test__msg__UnboundedSequence__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      performance_test__msg__UnboundedSequence__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

performance_test__msg__UnboundedSequence__Sequence *
performance_test__msg__UnboundedSequence__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  performance_test__msg__UnboundedSequence__Sequence * array = (performance_test__msg__UnboundedSequence__Sequence *)allocator.allocate(sizeof(performance_test__msg__UnboundedSequence__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = performance_test__msg__UnboundedSequence__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
performance_test__msg__UnboundedSequence__Sequence__destroy(performance_test__msg__UnboundedSequence__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    performance_test__msg__UnboundedSequence__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
performance_test__msg__UnboundedSequence__Sequence__are_equal(const performance_test__msg__UnboundedSequence__Sequence * lhs, const performance_test__msg__UnboundedSequence__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!performance_test__msg__UnboundedSequence__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
performance_test__msg__UnboundedSequence__Sequence__copy(
  const performance_test__msg__UnboundedSequence__Sequence * input,
  performance_test__msg__UnboundedSequence__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(performance_test__msg__UnboundedSequence);
    performance_test__msg__UnboundedSequence * data =
      (performance_test__msg__UnboundedSequence *)realloc(output->data, allocation_size);
    if (!data) {
      return false;
    }
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!performance_test__msg__UnboundedSequence__init(&data[i])) {
        /* free currently allocated and return false */
        for (; i-- > output->capacity; ) {
          performance_test__msg__UnboundedSequence__fini(&data[i]);
        }
        free(data);
        return false;
      }
    }
    output->data = data;
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!performance_test__msg__UnboundedSequence__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}
