// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from performance_test:msg/NavSatStatus.idl
// generated code does not contain a copyright notice
#include "performance_test/msg/detail/nav_sat_status__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>

#include "rcutils/allocator.h"


bool
performance_test__msg__NavSatStatus__init(performance_test__msg__NavSatStatus * msg)
{
  if (!msg) {
    return false;
  }
  // status
  // service
  return true;
}

void
performance_test__msg__NavSatStatus__fini(performance_test__msg__NavSatStatus * msg)
{
  if (!msg) {
    return;
  }
  // status
  // service
}

bool
performance_test__msg__NavSatStatus__are_equal(const performance_test__msg__NavSatStatus * lhs, const performance_test__msg__NavSatStatus * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // status
  if (lhs->status != rhs->status) {
    return false;
  }
  // service
  if (lhs->service != rhs->service) {
    return false;
  }
  return true;
}

bool
performance_test__msg__NavSatStatus__copy(
  const performance_test__msg__NavSatStatus * input,
  performance_test__msg__NavSatStatus * output)
{
  if (!input || !output) {
    return false;
  }
  // status
  output->status = input->status;
  // service
  output->service = input->service;
  return true;
}

performance_test__msg__NavSatStatus *
performance_test__msg__NavSatStatus__create()
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  performance_test__msg__NavSatStatus * msg = (performance_test__msg__NavSatStatus *)allocator.allocate(sizeof(performance_test__msg__NavSatStatus), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(performance_test__msg__NavSatStatus));
  bool success = performance_test__msg__NavSatStatus__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
performance_test__msg__NavSatStatus__destroy(performance_test__msg__NavSatStatus * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    performance_test__msg__NavSatStatus__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
performance_test__msg__NavSatStatus__Sequence__init(performance_test__msg__NavSatStatus__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  performance_test__msg__NavSatStatus * data = NULL;

  if (size) {
    data = (performance_test__msg__NavSatStatus *)allocator.zero_allocate(size, sizeof(performance_test__msg__NavSatStatus), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = performance_test__msg__NavSatStatus__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        performance_test__msg__NavSatStatus__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
performance_test__msg__NavSatStatus__Sequence__fini(performance_test__msg__NavSatStatus__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      performance_test__msg__NavSatStatus__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

performance_test__msg__NavSatStatus__Sequence *
performance_test__msg__NavSatStatus__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  performance_test__msg__NavSatStatus__Sequence * array = (performance_test__msg__NavSatStatus__Sequence *)allocator.allocate(sizeof(performance_test__msg__NavSatStatus__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = performance_test__msg__NavSatStatus__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
performance_test__msg__NavSatStatus__Sequence__destroy(performance_test__msg__NavSatStatus__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    performance_test__msg__NavSatStatus__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
performance_test__msg__NavSatStatus__Sequence__are_equal(const performance_test__msg__NavSatStatus__Sequence * lhs, const performance_test__msg__NavSatStatus__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!performance_test__msg__NavSatStatus__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
performance_test__msg__NavSatStatus__Sequence__copy(
  const performance_test__msg__NavSatStatus__Sequence * input,
  performance_test__msg__NavSatStatus__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(performance_test__msg__NavSatStatus);
    performance_test__msg__NavSatStatus * data =
      (performance_test__msg__NavSatStatus *)realloc(output->data, allocation_size);
    if (!data) {
      return false;
    }
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!performance_test__msg__NavSatStatus__init(&data[i])) {
        /* free currently allocated and return false */
        for (; i-- > output->capacity; ) {
          performance_test__msg__NavSatStatus__fini(&data[i]);
        }
        free(data);
        return false;
      }
    }
    output->data = data;
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!performance_test__msg__NavSatStatus__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}
